diff --git a/Makefile.am b/Makefile.am
index 1b6a513..84e90a4 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -10,4 +10,5 @@ SUBDIRS = \
   sesman \
   keygen \
   docs \
-  instfiles
+  instfiles \
+  dmx
diff --git a/common/defines.h b/common/defines.h
index 050eb5a..5fb1a42 100644
--- a/common/defines.h
+++ b/common/defines.h
@@ -89,5 +89,5 @@
   ((((f)->height * (((f)->width + 7) / 8)) + 3) & ~3);
 /* use crc for bitmap cache lookups */
 #define USE_CRC
-
+#define MAX_SESSIONS_LIMIT 128
 #endif
diff --git a/common/file.c b/common/file.c
index cf6f1e6..86aa3b8 100644
--- a/common/file.c
+++ b/common/file.c
@@ -86,7 +86,7 @@ l_file_read_sections(int fd, int max_file_size, struct list* names)
 }
 
 /*****************************************************************************/
-static int APP_CC
+int APP_CC
 file_read_line(struct stream* s, char* text)
 {
   int i;
@@ -155,7 +155,7 @@ file_read_line(struct stream* s, char* text)
 
 /*****************************************************************************/
 /* returns error */
-static int APP_CC
+int APP_CC
 file_split_name_value(char* text, char* name, char* value)
 {
   int len;
diff --git a/common/file.h b/common/file.h
index 9482a79..6c45db8 100644
--- a/common/file.h
+++ b/common/file.h
@@ -26,8 +26,13 @@
 #define FILE_H
 
 #include "arch.h"
+#include "parse.h"
 
 int APP_CC
+file_read_line(struct stream* s, char* text);
+int APP_CC
+file_split_name_value(char* text, char* name, char* value);
+int APP_CC
 file_read_sections(int fd, struct list* names);
 int APP_CC
 file_by_name_read_sections(const char* file_name, struct list* names);
diff --git a/common/os_calls.c b/common/os_calls.c
index b3a8043..e6ceace 100644
--- a/common/os_calls.c
+++ b/common/os_calls.c
@@ -60,6 +60,7 @@
 #include <string.h>
 #include <stdarg.h>
 #include <stdio.h>
+#include <dirent.h>
 #include <locale.h>
 
 #include "os_calls.h"
@@ -1626,6 +1627,13 @@ g_load_library(char* in)
 #if defined(_WIN32)
   return (long)LoadLibraryA(in);
 #else
+  char file[512];
+  void *handle;
+  g_snprintf(file, sizeof (file), XRDP_LIB_PATH "/%s", in);
+  file[sizeof (file) - 1] = '\0';
+  handle = dlopen(file, RTLD_LOCAL | RTLD_LAZY);
+  if (handle)
+    return (long) handle;
   return (long)dlopen(in, RTLD_LOCAL | RTLD_LAZY);
 #endif
 }
@@ -2030,3 +2038,54 @@ g_time2(void)
   return (int)(num_ticks * 10);
 #endif
 }
+
+/*****************************************************************************/
+/* returns 0 on error, else return handle */
+unsigned int APP_CC
+g_dir_open(const char * dir_name)
+{
+#if defined(_WIN32)
+  return 0;
+#else
+  return (unsigned int) opendir (dir_name);
+#endif
+}
+
+/*****************************************************************************/
+void APP_CC
+g_dir_close(unsigned int handle)
+{
+#if defined(_WIN32)
+#else
+  closedir ((DIR *) handle);
+#endif
+}
+
+/*****************************************************************************/
+const char* APP_CC
+g_dir_read_name(unsigned int handle)
+{
+#if defined(_WIN32)
+  return 0;
+#else
+  struct dirent *ent;
+
+  ent = readdir ((DIR *) handle);
+  if (!ent)
+    return 0;
+
+  return ent->d_name;
+#endif
+}
+
+/*****************************************************************************/
+/* returns -1 on error, else 0 is returned */
+int APP_CC
+g_gethostname(char *name, unsigned int len)
+{
+#if defined(_WIN32)
+  return -1;
+#else
+  return gethostname (name, len);
+#endif
+}
diff --git a/common/os_calls.h b/common/os_calls.h
index c9707ca..e4477a5 100644
--- a/common/os_calls.h
+++ b/common/os_calls.h
@@ -237,5 +237,13 @@ int APP_CC
 g_time1(void);
 int APP_CC
 g_time2(void);
+unsigned int APP_CC
+g_dir_open(const char * dir_name);
+void APP_CC
+g_dir_close(unsigned int handle);
+const char* APP_CC
+g_dir_read_name(unsigned int handle);
+int APP_CC
+g_gethostname(char *name, unsigned int len);
 
 #endif
diff --git a/common/xrdp_constants.h b/common/xrdp_constants.h
index f61c320..9532e77 100644
--- a/common/xrdp_constants.h
+++ b/common/xrdp_constants.h
@@ -430,6 +430,7 @@
 #define WND_TYPE_COMBO   7
 #define WND_TYPE_SPECIAL 8
 #define WND_TYPE_LISTBOX 9
+#define WND_TYPE_TILE    10
 
 /* button states */
 #define BUTTON_STATE_UP   0
diff --git a/configure.ac b/configure.ac
index 788c8a0..2de6359 100644
--- a/configure.ac
+++ b/configure.ac
@@ -19,19 +19,23 @@ AC_ARG_ENABLE(pamuserpass, AS_HELP_STRING([--enable-pamuserpass],
               [Build pam userpass support (default: no)]),
               [pamuserpass=true], [pamuserpass=false])
 AM_CONDITIONAL(SESMAN_PAMUSERPASS, [test x$pamuserpass = xtrue])
+PKG_CHECK_MODULES(DBUS, dbus-1)
+PKG_CHECK_MODULES(XAU, xau)
+PKG_CHECK_MODULES(XCB, xcb)
 libdir="${libdir}/xrdp/";
+AC_DEFINE_UNQUOTED([XRDP_LIB_PATH], ["${libdir}"], [xrdp lib dir])
 if test "x${prefix}" = "xNONE" ; then
 sysconfdir="/etc/";
 else
-AC_DEFINE_UNQUOTED([XRDP_CFG_PATH], ["${prefix}/etc/xrdp"], [xrdp config dir])
-AC_DEFINE_UNQUOTED([XRDP_CFG_FILE], ["${prefix}/etc/xrdp/xrdp.ini"], [xrdp config file])
-AC_DEFINE_UNQUOTED([XRDP_KEY_FILE], ["${prefix}/etc/xrdp/rsakeys.ini"], [xrdp key file])
-AC_DEFINE_UNQUOTED([XRDP_KEYMAP_FILE], ["${prefix}/etc/xrdp/km-%4.4x.ini"], [xrdp keymap file])
-AC_DEFINE_UNQUOTED([XRDP_PID_FILE], ["${prefix}/var/run/xrdp.pid"], [xrdp pid file])
+AC_DEFINE_UNQUOTED([XRDP_CFG_PATH], ["${sysconfdir}/xrdp"], [xrdp config dir])
+AC_DEFINE_UNQUOTED([XRDP_CFG_FILE], ["${sysconfdir}/xrdp/xrdp.ini"], [xrdp config file])
+AC_DEFINE_UNQUOTED([XRDP_KEY_FILE], ["${sysconfdir}/xrdp/rsakeys.ini"], [xrdp key file])
+AC_DEFINE_UNQUOTED([XRDP_KEYMAP_FILE], ["${sysconfdir}/xrdp/km-%4.4x.ini"], [xrdp keymap file])
+AC_DEFINE_UNQUOTED([XRDP_PID_FILE], ["${localstatedir}/run/xrdp.pid"], [xrdp pid file])
 AC_DEFINE_UNQUOTED([XRDP_SBIN_PATH], ["${prefix}/sbin"], [xrdp sbin dir])
 AC_DEFINE_UNQUOTED([XRDP_SHARE_PATH], ["${prefix}/share/xrdp"], [xrdp share dir])
-AC_DEFINE_UNQUOTED([SESMAN_PID_FILE], ["${prefix}/var/run/sesman.pid"], [sesman pid file])
-AC_DEFINE_UNQUOTED([SESMAN_CFG_FILE], ["${prefix}/etc/xrdp/sesman.ini"], [sesman config file])
+AC_DEFINE_UNQUOTED([SESMAN_PID_FILE], ["${localstatedir}/run/sesman.pid"], [sesman pid file])
+AC_DEFINE_UNQUOTED([SESMAN_CFG_FILE], ["${sysconfdir}/xrdp/sesman.ini"], [sesman config file])
 fi
 AC_CONFIG_FILES([Makefile
                  common/Makefile
@@ -49,6 +53,7 @@ AC_CONFIG_FILES([Makefile
                  docs/man/Makefile
                  instfiles/Makefile
                  instfiles/pam.d/Makefile
+                 dmx/Makefile
 ])
 #                 fontdump/Makefile
 #                 xrdp/cursors/Makefile
diff --git a/dmx/Makefile.am b/dmx/Makefile.am
new file mode 100644
index 0000000..d2cf026
--- /dev/null
+++ b/dmx/Makefile.am
@@ -0,0 +1,17 @@
+INCLUDES = \
+  -I$(top_srcdir)/common \
+  -I$(top_srcdir)/xrdp \
+  -I$(top_srcdir)/libxrdp \
+  $(DBUS_CFLAGS) \
+  $(XAU_CFLAGS)
+
+
+lib_LTLIBRARIES = \
+  libdmx.la
+
+libdmx_la_SOURCES = dmx.c
+
+libdmx_la_LIBADD = \
+  $(top_srcdir)/common/libcommon.la \
+  $(DBUS_LIBS) \
+  $(XAU_LIBS)
diff --git a/dmx/Makefile.osx b/dmx/Makefile.osx
new file mode 100644
index 0000000..fc77c1c
--- /dev/null
+++ b/dmx/Makefile.osx
@@ -0,0 +1,35 @@
+# libdmx makefile
+
+DMXOBJ = os_calls.o dmx.o
+
+DESTDIR = /usr/local/xrdp
+CFGDIR = /etc/xrdp
+PIDDIR = /var/run
+MANDIR = /usr/local/man
+DOCDIR = /usr/doc/xrdp
+
+DEFINES =
+
+LIBDMX = libdmx.dylib
+
+CFLAGS = -Wall -O2 -I../common `pkg-config --cflags dbus-1` -fPIC $(DEFINES)
+#CFLAGS += -DXRDP_DEBUG
+C_OS_FLAGS = $(CFLAGS) -c
+LDFLAGS = -dynamiclib -Wl,-flat_namespace -Wl,-undefined -Wl,suppress
+LIBS = `pkg-config --libs dbus-1` -ldl
+CC = gcc
+
+all: $(LIBDMX)
+
+$(LIBDMX): $(DMXOBJ)
+	$(CC) $(LDFLAGS) -o $(LIBDMX) $(DMXOBJ) $(LIBS)
+
+clean:
+	rm -f $(DMXOBJ) $(LIBDMX)
+
+os_calls.o: ../common/os_calls.c
+	$(CC) $(C_OS_FLAGS) ../common/os_calls.c
+
+install:
+	install $(LIBDMX) $(DESTDIR)/$(LIBDMX)
+
